#pragma once
#include "game_tab/Game.hpp"
#include <algorithm>
#include <vector>

class GameBase {

public:
  virtual Game *GetGame(std::uint32_t id) = 0;
  virtual void Save(std::vector<std::uint32_t> to_ignore,
                    std::vector<GameBase *> new_games_bases,
                    std::vector<Game *> new_games) = 0;
  virtual Game *GetCurrentGame() = 0;
  virtual bool NextGame() = 0;
  virtual std::string GetTag(std::string tag) = 0;
  virtual void Reset() = 0;
  /**
   * @brief Save the given base into current base format (export)
   * 
   * @param base 
   */
  virtual void Export(GameBase *base) = 0;
};